'this is the fastest (un)signed DWORD/QWORD  to ascii version I have.
'It could be tweaked to save a few clks by adding NOPs but I didn't have time
'call sdword for   signed dword to ascii
'call udword for unsigned dword to ascii
'call sqword for   signed qword to ascii
'call uqword for unsigned qword to ascii
'
'time taken depends on input but typically it's around 90 for a QWORD and 35 for a DWORD, 15 if 4 digits or less.
'The DWORD was 100% tested.
'The qword was tested as well as I could and I believe it works for all values.

%RDTSCP=&hf9010f


$REGISTER NONE
FUNCTION PBMAIN()
REM a routine TO time things IN clock cycles

limit&=10
DIM c&&(limit&)
GLOBAL pans AS BYTE PTR
GLOBAL pAnswer AS LONG



a&&=0:b&&=0
'######################
'do any setting up of variables here

!jmp over
sizestart:
#ALIGN 32

chartab:
!dd "00","10","20","30","40","50","60","70","80","90"
!dd "01","11","21","31","41","51","61","71","81","91"
!dd "02","12","22","32","42","52","62","72","82","92"
!dd "03","13","23","33","43","53","63","73","83","93"
!dd "04","14","24","34","44","54","64","74","84","94"
!dd "05","15","25","35","45","55","65","75","85","95"
!dd "06","16","26","36","46","56","66","76","86","96"
!dd "07","17","27","37","47","57","67","77","87","97"
!dd "08","18","28","38","48","58","68","78","88","98"
!dd "09","19","29","39","49","59","69","79","89","99"


CodeStart:
'on entry edx:eax=number, ecx=pointer to buffer for answer (must be at least 22 bytes)
'on exit eax,ecx,edx undefined all other registers unchanged
'answer is zero terminated ascii string and buffer pointed to by ecx on entry
'call sqword for   signed qword to ascii
'call uqword for unsigned qword to ascii

sqword:
!or edx,edx             'test sign
!jns short uqword       'not negative so continue as unsigned
!not edx                'negate the 64 bit number in edx:eax
!neg eax
!sbb edx,-1

!mov byte ptr [ecx],"-" 'write - sign to buffer
!inc ecx                'update pointer

uqword:
!or edx,edx             'if top word is not used then..
!jz udword              ' .. use unsigned Dword routine as it's faster

!push ebp               'save ebp
!push esi               'save esi
!mov ebp,eax            'save a copy of low word for later
!mov esi,edx            'save a copy of high word for later
!mov pAnswer,ecx        'save a copy of buffer pointer for later, don't stack it or it's awkward to get back

'do 64 bit multiply by 2^110\1e14+1 to make it more likely I get no rounding errors = &H b424dc35 095cd810
'this is a 4 part operation, LOxLO, LOxHI, HIxLO, HIxHI and add the 4 results offset appropriately
!mov ecx,&h095cd810     '2^110\1e14+1 low word

!mul ecx                '
!mov eax,esi            'get number high word, LSBs of MUL not needed so they're ignored

!nop

!push edi               'save other used registers
!push ebx               'save other used registers

!mov edi,edx            'save high word of result
!mul ecx                'now do high word mul


!mov ecx,&hb424dc35     'get ready for other half of MUL
!add edi,eax            'Add low word into result
!adc edx,0              'and handle the possible carry


!mov eax,ebp            'Get low word of number again
!mov ebx,edx            'save high word of answer

!mul ecx                'do next part
!add edi,eax            'add into answer
!mov eax,esi            'get high word of number

!adc ebx,edx            'add it in to answer #####? possible carry to higher word? probably not..
!mul ecx                'do final mul


!mov ecx,1000000        'ready for later
!add ebx,eax            'add in result
!adc edx,0              'and carry

!add edi,16384          'round up last bit to decrease error to within that required.
!adc ebx,0
!adc edx,0

!shrd edi,ebx,14        'correct for the 14 bit shift used to increase accuracy
!shrd ebx,edx,14
!shr edx,14             'edx contains top 6 digits, edi:ebx contain the information to get the next 6 digits


'64 bit multiply done
'result in edx:ebx:edi  , original number in esi:ebp

'x 1000000 to get next 6 digits
!mov eax,edi
!mov esi,edx            'save top6 in esi

!mul ecx
!mov eax,ebx                'do low word x1000000
!mov ebx,edx                '
!mul ecx                    'do high word x 1000000

!add eax,ebx                'add both together
!adc edx,0

!mov ebx,edx                'save 2nd 6 in ebx

'now get ((top6 x 1e6) + next6)*1e8 and sub from original number to leave last 8 digits
'since the 8 digits we want are all contained in the low word we can completely ignore the high word
'this allows imul and does away with carries to the high word
!mov eax,esi               'get top 6
!imul eax,ecx              'top 6 x 1000000
!mov ecx,100000000
!add eax,ebx               'top6 x 1000000 + next 6
!imul eax, ecx
!sub ebp,eax               'ebp=last 8 digits

'20 digits broken into 6,6,8 now display them
'esi=top6, ebx=next 6, ebp=last 8

'do top 6 digits
!mov eax,esi                'get top 6 digits
!mov edi,&h68db9            '=2^32\10000+1
!mul edi

!mov esi,pAnswer            'get pointer into answer buffer
!mov ecx,100                 'multiplier for later

!jnc short qnext1            'if zero, supress them by ignoring
!cmp edx,9                  '1 digit or 2?
!ja  short qZeroSupressed    '2 digits, just continue with pairs of digits to the end

!mov edx,chartab[edx*4]     'look up 2 digits
!mov [esi],dh               'but only write the 1 we need, supress the leading zero
!inc esi                    'update pointer by 1
!jmp short qZS1              'continue with pairs of digits to the end

qnext1:
!mul ecx                    'get next 2 digits
!jnc short qnext2            'if zero, supress them by ignoring
!cmp edx,9                  '1 digit or 2?
!ja  short qZS1a             '2 digits, just continue with pairs of digits to the end

!mov edx,chartab[edx*4]     'look up 2 digits
!mov [esi],dh               'but only write the 1 we need, supress the leading zero
!inc esi                    'update pointer by 1
!jmp short qZS2              'continue with pairs of digits to the end

qnext2:
!mul ecx                    'get next 2 digits
!jnc short qnext3            'if zero, supress them by ignoring
!cmp edx,9                  '1 digit or 2?
!ja  short qZS2a             '2 digits, just continue with pairs of digits to the end

!mov edx,chartab[edx*4]     'look up 2 digits
!mov [esi],dh               'but only write the 1 we need, supress the leading zero
!inc esi                    'update pointer by 1
!jmp short qZS3              'continue with pairs of digits to the end

'next 6 digits
qnext3:
!mov eax,ebx                'get 2nd 6 digits
!mov ebx,&h28F5C29          '=2^32\100+1  ready for later
!mul edi                    'edi=2^32\10000+1

!jnc short qnext4            'if zero, supress them by ignoring
!cmp edx,9                  '1 digit or 2?
!ja  short qZS3a             '2 digits, just continue with pairs of digits to the end

!mov edx,chartab[edx*4]     'look up 2 digits
!mov [esi],dh               'but only write the 1 we need, supress the leading zero
!inc esi                    'update pointer by 1
!jmp short qZS4              'continue with pairs of digits to the end


qnext4:
!mul ecx                    'get next 2 digits
!jnc short qzs5             'if zero, supress them by ignoring
!cmp edx,9                  '1 digit or 2?
!ja  short qZS4a             '2 digits, just continue with pairs of digits to the end

!mov edx,chartab[edx*4]     'look up 2 digits
!mov [esi],dh               'but only write the 1 we need, supress the leading zero
!inc esi                    'update pointer by 1
!jmp short qZS5              'continue with pairs of digits to the end

'done top 10 digits
'since we took a short cut to the DWORD routine at the start we can never get beyond here
'as the DWORD routine would handle it instead.
'At this point we are guaranteed to have exactly 10 digits to print so just jump to the relevant spot.


qZeroSupressed:
!mov edx,chartab[edx*4]     'look up the 2 digits
!mov [esi],dx
!add esi,2
QZS1:
!mul ecx
QZS1a:
!mov edx,chartab[edx*4]     'look up the 2 digits
!mov [esi],dx
!add esi,2
QZS2:
!mul ecx
QZS2a:
!mov edx,chartab[edx*4]     'look up the 2 digits
!mov [esi],dx
!add esi,2

sj:
QZS3:
'do next 6 digits
!mov eax,ebx                'get 2nd 6 digits
!mov ebx,&h28F5C29          '=2^32\100+1  ready for later
!mul edi                    'edi=2^32\10000+1
QZS3a:
!mov edx,chartab[edx*4]
!mov [esi],dx
!add esi,2

QZS4:
!mul ecx
QZS4a:
!mov edx,chartab[edx*4]
!mov [esi],dx
!add esi,2

QZS5:
!mul ecx
QZS5a:
!mov edx,chartab[edx*4]
!mov [esi],dx
!add esi,2

'do final 8 digits

!mov eax,ebp                'get last 8 digits

!mul ebx                    'ebx=2^32\100+1
!mov eax,edx
!mov ebx,edx
!mul edi                    'edi=2^32\10000+1

!mov edx,chartab[edx*4]     'look up next 2 digits
!mov [esi],dx
!add esi,2

!mul ecx
!mov edx,chartab[edx*4]     'look up next 2 digits
!mov [esi],dx
!add esi,2
!mul ecx
!mov edx,chartab[edx*4]    'look up next 2 digits
!mov [esi],dx
!add esi,2

!mov eax,ebx               'first 6 digits of last 8
!imul eax,ecx              'x100 to shift into place

!pop ebx                   'restore
!pop edi                   'restore

!mov edx,ebp               'last 8 - 6 just done gives final 2 digits

!sub edx,eax               'look up final 2 digits
!mov edx,chartab[edx*4]
!mov [esi],dx
!add esi,2
!mov byte ptr [esi],0      'need to zero terminate

!pop esi                  'restore
!pop ebp                  'restore

AllDone:
!ret



'make sure this code is 16 byte aligned
'on entry eax=number to convert, ecx=pointer to answer buffer (must have room for minimum of 12 bytes)
'on exit, eax,ecx,edx are undefined, all other registers are preserved.
'answer is in location pointed to by ecx on entry
'call sdword to do   signed DWORD to ASCII
'call udword to do unsigned DWORD to ASCII
'excluding the call/return overhead this code converts 4 digit numbers in 12 Athlon clks (about 40 P4 clks)
'5-10 digit numbers take 30 Athlon clks (about 76 P4 clks)

#ALIGN 16

sdword:
'do a signed DWORD to ASCII
!or eax,eax                 'test sign
!jns udword                 'if +ve, continue as for unsigned
!neg eax                    'else, make number positive
!mov byte ptr [ecx],"-"     'include the - sign
!inc ecx                    'update the pointer


udword:
'unsigned DWORD to ASCII
!push edi                   'save registers that need to be saved
!push esi

!mov esi,ecx                'get pointer to answer
!mov edi,eax                'save a copy of the number

!mov edx, &hD1B71759        '=2^45\10000    13 bit extra shift
!mul edx                    'gives 6 high digits in edx

!mov eax,&h68DB9            '=2^32\10000+1

!shr edx,13                 'correct for multiplier offset used to give better accuracy
!jz short skiphighdigits    'if zero then don't need to process the top 6 digits


!mov ecx,edx                'get a copy of high digits
!imul ecx,10000             'scale up high digits
!sub edi,ecx                'subtract high digits from original. EDI now = lower 4 digits


!mul edx                    'get first 2 digits in edx
!mov ecx,100                'load ready for later

!jnc short next1            'if zero, supress them by ignoring
!cmp edx,9                  '1 digit or 2?
!ja  short ZeroSupressed    '2 digits, just continue with pairs of digits to the end

!mov edx,chartab[edx*4]     'look up 2 digits
!mov [esi],dh               'but only write the 1 we need, supress the leading zero
!inc esi                    'update pointer by 1
!jmp short ZS1              'continue with pairs of digits to the end

next1:
!mul ecx                    'get next 2 digits
!jnc short next2            'if zero, supress them by ignoring
!cmp edx,9                  '1 digit or 2?
!ja  short ZS1a             '2 digits, just continue with pairs of digits to the end

!mov edx,chartab[edx*4]     'look up 2 digits
!mov [esi],dh               'but only write the 1 we need, supress the leading zero
!inc esi                    'update pointer by 1
!jmp short ZS2              'continue with pairs of digits to the end

next2:
!mul ecx                    'get next 2 digits
!jnc short next3            'if zero, supress them by ignoring
!cmp edx,9                  '1 digit or 2?
!ja  short ZS2a             '2 digits, just continue with pairs of digits to the end

!mov edx,chartab[edx*4]     'look up 2 digits
!mov [esi],dh               'but only write the 1 we need, supress the leading zero
!inc esi                    'update pointer by 1
!jmp short ZS3              'continue with pairs of digits to the end

next3:

skiphighdigits:
!mov eax,edi                'get lower 4 digits

!mov ecx,100

!mov edx,&h28F5C29          '2^32\100 +1
!mul edx
!jnc short next4            'if zero, supress them by ignoring
!cmp edx,9                  '1 digit or 2?
!ja  short ZS3a             '2 digits, just continue with pairs of digits to the end

!mov edx,chartab[edx*4]     'look up 2 digits
!mov [esi],dh               'but only write the 1 we need, supress the leading zero
!inc esi                    'update pointer by 1
!jmp short  ZS4             'continue with pairs of digits to the end

next4:
!mul ecx                    'this is the last pair so don't supress a single zero
!cmp edx,9                  '1 digit or 2?
!ja  short ZS4a             '2 digits, just continue with pairs of digits to the end

!mov edx,chartab[edx*4]     'look up 2 digits
!mov [esi],dh               'but only write the 1 we need, supress the leading zero
!mov byte ptr [esi+1],0     'zero terminate string

!jmp short  xit               'all done


ZeroSupressed:
!mov edx,chartab[edx*4]     'look up 2 digits
!mov [esi],dx
!add esi,2                  'write them to answer

ZS1:
!mul ecx                    'get next 2 digits
ZS1a:
!mov edx,chartab[edx*4]     'look up 2 digits
!mov [esi],dx               'write them to answer
!add esi,2

ZS2:
!mul ecx                    'get next 2 digits
ZS2a:
!mov edx,chartab[edx*4]     'look up 2 digits
!mov [esi],dx               'write them to answer
!add esi,2

ZS3:
!mov eax,edi                'get lower 4 digits
!mov edx,&h28F5C29          '2^32\100 +1
!mul edx                    'edx= top pair
ZS3a:
!mov edx,chartab[edx*4]     'look up 2 digits
!mov [esi],dx               'write to answer
!add esi,2                  'update pointer

ZS4:
!mul ecx                    'get final 2 digits
ZS4a:
!mov edx,chartab[edx*4]     'look them up
!mov [esi],dx               'write to answer

!mov byte ptr [esi+2],0     'zero terminate string

xit:
!pop esi                    'restore used registers
!pop edi
sdwordend:
!ret


sizeend:

'n:
'!dd &hBD2DA713,&h1121E785 '  1234522334466778899
'!dd &h55667788,&h11223344
'!dd &hffffffff, &hffffffff
'!dd  &h89E7FFFF,&h8AC72304     '9999999999999999999
'!dd  &h5E238E38, &h7B5BAD59    '8888888888888888888
'! dd 1234545,0


over:


DIM ans AS ASCIIZ * 22
DIM pans AS BYTE PTR
ans="00000000000000000000x"
pans=VARPTR(ans)


'n&&= 9999999999999999999



'end of setting up
'########################



FOR r& = 1 TO limit&
n&&= -5222222200000000000'-12345223344

!pushad
'!cli
!cpuid
!RDTSC

'!db &h0f, &h01, &hf9 'RDTSCP
!mov a&&[4],edx
!mov a&&,eax
'#################
'place the code to time here.
!mov ecx,pans
!mov eax,n&&
!mov edx,n&&[4] '&h81234567


'!lea eax,[eax+0]
'!db &h08d,&h44,&h20,&h0

!call sqword 'CodeStart
'!call alldone


'end of timed code
'#################
!cpuid

!RDTSC
'!db &h0f, &h01, &hf9 'RDTSCP

!mov b&&[4],edx
!mov b&&,eax
'!sti
!popad

c&&(r&)=(b&&-a&&) -120
NEXT

FOR r& = 1 TO limit&
    PRINT r&,c&&(r&)
    NEXT

    PRINT "an&&=";an&&
    PRINT "ans=";ans

    PRINT "size="CODEPTR(sizeend)-CODEPTR(sizestart)
    PRINT "code start=";HEX$(CODEPTR(CodeStart))
    PRINT "chartab=";HEX$(CODEPTR(chartab))

WAITKEY$
END FUNCTION
